#define ZASM_PP_ENTRY_C 1

#include <zasm/pp_entry.h>
#include <zasm/string_alloc.h>
ALLOC_DEFINE(pp_entry, ALLOC_DEF_COUNT);

struct pp_entry_t *pp_entry_new(struct pp_level_t *level, char *name, struct pp_macro_t *macro)
{
  struct pp_entry_t *val = pp_entry_alloc_get(&(level->entry_alloc));
  pp_entry_fill(val, level, name, macro);
  return val;
}

void pp_entry_fill(struct pp_entry_t *entry, struct pp_level_t *level, char *name, struct pp_macro_t *macro)
{
  hash_entry_fill(&(entry->entry), string_alloc_copy(&(level->string_alloc), name));
  entry->macro = macro;
}

void pp_entry_redef(struct pp_entry_t *entry, struct pp_macro_t *macro)
{
  pp_macro_free(entry->macro);
  entry->macro = macro;
}

void pp_entry_delete(struct pp_entry_t *entry)
{}

void pp_entry_free(struct pp_entry_t *entry)
{}
