#define ZASM_PP_MACRO_C 1

#include <zasm/pp_macro.h>

ALLOC_DEFINE_DELETE(pp_macro, ALLOC_DEF_COUNT);

struct pp_macro_t *pp_macro_new(struct pp_level_t *level, struct list_t *args, struct list_t *body)
{
  struct pp_macro_t *val = pp_macro_alloc_get(&(level->macro_alloc));

  pp_macro_fill(val, args, body);
  return val;
}

void pp_macro_fill(struct pp_macro_t *macro, struct list_t *args, struct list_t *body)
{
  macro->args = args;
  macro->body = body;
}

void pp_macro_delete(struct pp_macro_t *macro)
{
  list_dec_refcount(macro->args);
  list_dec_refcount(macro->body);
}

void pp_macro_free(struct pp_macro_t *macro)
{}
