#ifndef ZASM_PREPROCESSOR_H
#define ZASM_PREPROCESSOR_H 1

#include <zasm/pp_namespace.h>
#include <zasm/stream.h>

#define PREPROCESSOR_T(O) ((struct preprocessor_t *)(O))
struct preprocessor_t
{
  char *path;
  char **include_dirs;
  struct token_t look_ahead;
  struct pp_namespace_t *ns;
  struct expr_alloc_t *expr_alloc; // reset in preprocessor_execute
};

struct preprocessor_t *preprocessor_new(char *path, char **include_dirs);
void preprocessor_fill(struct preprocessor_t *pp, char *path, char **include_dirs);
char *preprocessor_get_include_file(struct preprocessor_t *pp, char *name);
void preprocessor_execute(struct feeder_t *input, struct stream_t *output, struct preprocessor_t *pp);
void preprocessor_delete(struct preprocessor_t *pp);
void preprocessor_free(struct preprocessor_t *pp);

#endif
